'From Squeak4.5 of 21 May 2015 [latest update: #15023] on 26 May 2015 at 8:05:47 pm'!
"Change Set:		DateAndTimeCreationSpeedup
Date:			26 May 2015
Author:			David T Lewis

Changes provided by Levente Uzonyi to make instance creation be more than twice as fast. Also update #hasUtcPrim to reflect Levente's change. See squeak-dev list topic 'UTCDateAndTime updated for Squeak 4.6/5.0' "!


!DateAndTime class methodsFor: 'ansi protocol' stamp: 'ul 5/25/2015 11:50'!
now

	self primPosixMicrosecondClockWithOffset ifNotNil: [ :timeArray |
		^self utcMicroseconds: (timeArray at: 1) offset: (timeArray at: 2) ].
	"Use old style primitive support"
	^self nowWithOffset: self localOffset
		! !

!DateAndTime class methodsFor: 'initialize-release' stamp: 'dtl 5/26/2015 19:58'!
hasUtcPrim
	^ self primPosixMicrosecondClockWithOffset notNil
! !

!DateAndTime class methodsFor: 'DTL' stamp: 'ul 5/24/2015 23:39'!
primPosixMicrosecondClockWithOffset
	"Answer an array with UTC microseconds since the Posix epoch and the
	current seconds offset from GMT in the local time zone."

	<primitive: 'primitiveUtcWithOffset'>
	^nil! !

!DateAndTime class methodsFor: 'DTL' stamp: 'ul 5/25/2015 11:52'!
utcMicroseconds: microsecondsSincePosixEpoch offset: offsetSeconds

	^self basicNew
		utcMicroseconds: microsecondsSincePosixEpoch
		offset: offsetSeconds! !

